;------------------------------------------------------------------------------
; loadpic.asm	       (C) 2004 by Michael S. Lorenz, all rights reserved.
; 
; Generic app that reads a picture file and displays it.
;
; YYMMDD	NOTES
; ------	-----
; 040703	Programming begun, based on MSKB article 218972 - LOADPIC.EXE.
;	Thanks to Jibz from the MASM32 forum for all his help!
; 040705	Added greyscale and sepia filters.
;------------------------------------------------------------------------------
; Set tabs to every 10 spaces.

.686
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comdlg32.inc

include \masm32\com\include\oaidl.inc
include \masm32\include\olepro32.inc
include \masm32\include\ole32.inc

include resource.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\olepro32.lib

;-------------------------------------------------------------------------------
; CONSTANTS
;-------------------------------------------------------------------------------

	HIMETRIC_INCH	equ	2540

;-------------------------------------------------------------------------------
; MACROS
;-------------------------------------------------------------------------------

m2m	macro	M1:REQ, M2:REQ		; move mem to mem
	push	M2
	pop	M1
endm

_T	macro	sz:VARARG			; in-place text string
	local	sztext
	.data
	ifidni	<sz>,<>
		sztext	db 0
	else
		sztext	db sz, 0
	endif
	.code
	exitm	<offset sztext>
endm

;-------------------------------------------------------------------------------
; IPICTURE COM INTERFACE
;-------------------------------------------------------------------------------

sIID_IPicture TEXTEQU <{07BF80980H, 0BF32H, 0101AH, {08BH, 0BBH, 000H, 0AAH, 000H, 030H, 00CH, 0ABH}}>

_vtIPicture MACRO CastName:REQ
	&CastName&_QueryInterface comethod3 ?
	&CastName&_AddRef comethod1 ?
	&CastName&_Release comethod1 ?
	&CastName&_get_Handle comethod2 ?
	&CastName&_get_hPal comethod2 ?
	&CastName&_get_Type comethod2 ?
	&CastName&_get_Width comethod2 ?
	&CastName&_get_Height comethod2 ?
	&CastName&_Render comethod11 ?
	&CastName&_set_hPal comethod2 ?
	&CastName&_get_CurDC comethod2 ?
	&CastName&_SelectPicture comethod4 ?
	&CastName&_get_KeepOriginalFormat comethod2 ?
	&CastName&_put_KeepOriginalFormat comethod2 ?
	&CastName&_PictureChanged comethod1 ?
	&CastName&_SaveAsFile comethod4 ?
	&CastName&_get_Attributes comethod2 ?
ENDM

IPicture STRUCT
	_vtIPicture IPicture
IPicture ENDS

;-------------------------------------------------------------------------------
; ISTREAM COM INTERFACE
;-------------------------------------------------------------------------------

sIID_IStream TEXTEQU <{00000000cH, 00000H, 00000H, {0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>

_vtIStream MACRO CastName:REQ
	&CastName&_QueryInterface comethod3 ?
	&CastName&_AddRef comethod1 ?
	&CastName&_Release comethod1 ?
	&CastName&_Read comethod4 ?
	&CastName&_Write comethod4 ?
	&CastName&_Seek comethod4 ?
	&CastName&_SetSize comethod2 ?
	&CastName&_CopyTo comethod5 ?
	&CastName&_Commit comethod2 ?
	&CastName&_Revert comethod1 ?
	&CastName&_LockRegion comethod4 ?
	&CastName&_UnlockRegion comethod4 ?
	&CastName&_Stat comethod3 ?
	&CastName&_Clone comethod2 ?
ENDM

IStream STRUCT
	_vtIStream IStream
IStream ENDS

;-------------------------------------------------------------------------------
; PROTOTYPES
;-------------------------------------------------------------------------------

WinMain	proto	hinst:DWORD, hprev:DWORD, cmdline:DWORD, cmdshow:DWORD

;-------------------------------------------------------------------------------
; DATA
;-------------------------------------------------------------------------------

.data

	IID_IPicture	GUID	sIID_IPicture
	ghbmp		HBITMAP	0
	wndclass		db	"Class_"
	wndtitle		db	"LoadPic", 0
	szfiletypes	db	"Supported Files Types(*.bmp;*.gif;*.jpg;*.ico;*.emf;*.wmf)",0,"*.bmp;*.gif;*.jpg;*.ico;*.emf;*.wmf",0,"Bitmaps (*.bmp)",0,"*.bmp",0,"GIF Files (*.gif)",0,"*.gif",0,"JPEG Files (*.jpg)",0,"*.jpg",0,"Icons (*.ico)",0,"*.ico",0,"Enhanced Metafiles (*.emf)",0,"*.emf",0,"Windows Metafiles (*.wmf)",0,"*.wmf",0,0

.data?

	hinst	HINSTANCE ?
	cmdline	LPSTR	?

.code

;-------------------------------------------------------------------------------
; CODE
;-------------------------------------------------------------------------------

align	16
start:	invoke	GetModuleHandle, NULL
	mov	hinst, eax
	invoke	GetCommandLine
	mov	cmdline, eax

	invoke	WinMain, hinst, NULL, cmdline, SW_SHOWDEFAULT
	invoke	ExitProcess, eax

;-------------------------------------------------------------------------------
; Read picture file into memory. Returns EAX <- handle to new memory,
; ECX <- file size. Use GlobalFree to free it. If there's an error,
; EAX will be zero & ECX will point to an explanatory string.

align	16
readfile	proc uses ebx edi esi, pathname:ptr byte

	local	nread:dword

	mov	nread, 0

	; open file, EBX <- file handle

	xor	ecx, ecx
	invoke	CreateFile, pathname, GENERIC_READ, ecx, ecx, OPEN_EXISTING, ecx, ecx
	mov	ebx, eax
	cmp	ebx, INVALID_HANDLE_VALUE
	je	E1

	; ESI <- file size

	xor	ecx, ecx
	invoke	GetFileSize, ebx, ecx
	mov	esi, eax

	; EDI <- handle to newly allocated buffer

	invoke	GlobalAlloc, GMEM_MOVEABLE, esi
	mov	edi, eax
	test	edi, edi
	jz	E2

	; read entire file into buffer & close it

	invoke	GlobalLock, edi
	mov	edx, eax
	xor	ecx, ecx
	invoke	ReadFile, ebx, edx, esi, ADDR nread, ecx
	test	eax, eax
	jz	E3
	invoke	GlobalUnlock, edi
	invoke	CloseHandle, ebx

	; done - set return values

	mov	ecx, esi
	mov	eax, edi
	test	eax, eax
	jmp	EXIT

	; errors

E1:	mov	ecx, _T("readfile: unable to open file.")
	jmp	FAIL

E2:	invoke	CloseHandle, ebx
	mov	ecx, _T("readfile: unable to allocate memory to read image.")
	jmp	FAIL

E3:	mov	ecx, _T("readfile: unable to read file.")

FAIL:	xor	eax, eax
EXIT:	ret

readfile	endp

;-------------------------------------------------------------------------------
; Load picture file from a memory handle into an IPicture pointer.
; The ppic argument is a ptr to a ptr to an IPicture structure, and must
; either be zero or a valid ptr to an IPicture object. Returns 0/1 in EAX
; to indicate success. If failure, ECX points to explanation string.

align	16
loadipic	proc, hmem:dword, offsetbytes:dword, memsize:dword, ppic:dword

	local	pstream:dword

	mov	pstream, 0

	; create IStream ptr from global memory

	invoke	CreateStreamOnHGlobal, hmem, TRUE, ADDR pstream
	cmp	eax, S_OK
	jne	E1
	cmp	pstream, 0
	je	E2

	; create IPicture from image file

	cmp	offsetbytes, 0
	je	@F
	xor	ecx, ecx
	coinvoke	pstream, IStream, Seek, offsetbytes, ecx, ecx
	cmp	eax, S_OK
	jne	E3
@@:
	invoke	OleLoadPicture, pstream, memsize, FALSE, ADDR IID_IPicture, ppic
	cmp	eax, S_OK
	jne	E4

	; release the stream

	coinvoke	pstream, IStream, Release

	; done - set return values

	xor	ecx, ecx
	xor	eax, eax
	inc	eax
	jmp	EXIT

	; errors

E1:	mov	ecx, _T("loadipic: CreateStreamOnHGlobal error")
	jmp	FAIL
E2:	mov	ecx, _T("loadipic: CreateStreamOnHGlobal OK but returned null stream")
	jmp	FAIL
E3:	coinvoke	pstream, IStream, Release
	mov	ecx, _T("loadipic: IStream::Seek error")
	jmp	FAIL
E4:	coinvoke	pstream, IStream, Release
	mov	ecx, _T("loadipic: OleLoadPicture error")

FAIL:	xor	eax, eax
EXIT:	ret

loadipic	endp

;-------------------------------------------------------------------------------
; Load picture file from a memory handle into an IPicture pointer.
; The ppic argument is a ptr to a ptr to an IPicture structure, and must
; either be zero or a valid ptr to an IPicture object. Returns 0/1 in EAX
; to indicate success. If failure, ECX points to explanation string.

align	16
loadbmp	proc uses ebx edi esi, hmem:dword, offsetbytes:dword, memsize:dword

	local	retval:dword, errmsg:dword, ipic:dword
	local	wmetric:DWORD, hmetric:DWORD
	local	wpixels:DWORD, hpixels:DWORD
	local	oldobject:DWORD
	local	bmi:BITMAPINFO

	; assume failure

	mov	retval, 0
	mov	errmsg, _T("loadbmp error")

	; get IPicture

	invoke	loadipic, hmem, offsetbytes, memsize, ADDR ipic
	jz	EXIT

	; get image size

	coinvoke	ipic, IPicture, get_Width, ADDR wmetric
	coinvoke	ipic, IPicture, get_Height, ADDR hmetric

	; EDI <- temporary HDC compatible with screen

	invoke	CreateCompatibleDC, 0
	mov	edi, eax

	; convert himetric dimensions to pixels

	invoke	GetDeviceCaps, edi, LOGPIXELSX
	xor	edx, edx
	mul	wmetric
	mov	ecx, HIMETRIC_INCH
	div	ecx
	mov	wpixels, eax

	invoke	GetDeviceCaps, edi, LOGPIXELSY
	xor	edx, edx
	mul	hmetric
	mov	ecx, HIMETRIC_INCH
	div	ecx
	mov	hpixels, eax

	; EBX <- new empty HBITMAP

	invoke	RtlZeroMemory, ADDR bmi.bmiHeader, SIZEOF bmi.bmiHeader

	mov	bmi.bmiHeader.biSize,	SIZEOF bmi.bmiHeader
	m2m	bmi.bmiHeader.biWidth,	wpixels
	m2m	bmi.bmiHeader.biHeight,	hpixels
	mov	bmi.bmiHeader.biPlanes,	1
	mov	bmi.bmiHeader.biBitCount,	32
	mov	bmi.bmiHeader.biCompression,	BI_RGB

	xor	ecx, ecx
	invoke	CreateDIBSection, edi, ADDR bmi, DIB_RGB_COLORS, ecx, ecx, ecx
	mov	ebx, eax
	test	ebx, ebx
	jz	E3

	invoke	GdiFlush

	; select the new bitmap into our temp HDC

	invoke	SelectObject, edi, ebx
	mov	oldobject, eax

	; render the IPicture into our new bitmap

	mov	esi, hmetric
	neg	esi
	xor	ecx, ecx
	coinvoke	ipic, IPicture, Render, edi, ecx, ecx, wpixels, hpixels, ecx, hmetric, wmetric, esi, ecx
	cmp	eax, S_OK
	jne	E4

	; ok

	mov	retval, ebx
	mov	errmsg, 0

	; clean up

E4:	invoke	SelectObject, edi, oldobject
E3:	invoke	DeleteDC, edi
E2:	coinvoke	ipic, IPicture, Release

DONE:	mov	ecx, errmsg
	mov	eax, retval
	test	eax, eax

EXIT:	ret

loadbmp	endp

;-------------------------------------------------------------------------------
; Process HBITMAP using a callback filter. Basically this just gets the bits
; ready, then calls the callback once to process them.

bmpfilter	proc uses ebx edi esi, hbmp:dword, func:dword

	local bm:BITMAP
	local newmem:dword, bmbytes:dword

	invoke GetObject, hbmp, sizeof bm, ADDR bm

	; calc total bitmap bytes

	xor	edx, edx
	mov	eax, bm.bmWidthBytes
	mul	bm.bmHeight
	mov	bmbytes, eax

	; allocate memory for new bitmap bits

	invoke	GlobalAlloc, GMEM_FIXED, eax
	test	eax, eax
	jz	EXIT
	mov	newmem, eax

	; get a copy of the bitmap's bits

	invoke	GetBitmapBits, hbmp, bmbytes, eax

	; call the callback function to process the bits

	lea	eax, bm
	push	eax
	push	bmbytes
	push	newmem
	mov	eax, func
	call	eax

	; wrap it up

	invoke	SetBitmapBits, hbmp, bmbytes, newmem
	invoke	GlobalFree, newmem
EXIT:	ret

bmpfilter	endp

;-------------------------------------------------------------------------------
; Callback for bmpfilter. Converts RGB color to greyscale.

greyscale	proc uses ebx edi esi, pbits:dword, nbytes:dword, pbm:dword

	; ESI <- first pixel, EDI <- one past last pixel

	mov	esi, pbits
	mov	edi, esi
	add	edi, nbytes

	; goto appropriate algorithm (EBX <- # of bytes per pixels: 3 or 4)

	mov	ebx, pbm
	movzx	eax, (BITMAP PTR [ebx]).bmBitsPixel
	mov	ebx, 4
	cmp	eax, 32
	je	GREY
	dec	ebx
	cmp	eax, 24
	je	GREY
	JMP	EXIT

GREY:	.while	esi < edi

		movzx	ecx, byte ptr[esi+2]     ; red
		imul	ecx, ecx, 77

		movzx	edx, byte ptr[esi+1]     ; green
		imul	edx, edx, 150
		add	ecx, edx

		movzx	eax, byte ptr[esi]       ; blue
		imul	eax, eax, 29

		lea	eax, [eax+ecx+128]
		shr	eax, 8

		mov	[esi+2], al
		mov	[esi+1], al
		mov	[esi], al

		add	esi, ebx

	.endw

EXIT:	ret

greyscale	endp

;-------------------------------------------------------------------------------
; Callback for bmpfilter. Converts RGB color to sepia-shaded greyscale that
; looks like an old photograph. It's done simply by doing a normal greyscale,
; then adding a little red and subtracting a little blue. This is unoptimized!

sepia	proc uses ebx edi esi, pbits:dword, nbytes:dword, pbm:dword

	; ESI <- first pixel, EDI <- one past last pixel

	mov	esi, pbits
	mov	edi, esi
	add	edi, nbytes

	; goto appropriate algorithm (EBX <- # of bytes per pixels: 3 or 4)

	mov	ebx, pbm
	movzx	eax, (BITMAP PTR [ebx]).bmBitsPixel
	mov	ebx, 4
	cmp	eax, 32
	je	GREY
	dec	ebx
	cmp	eax, 24
	je	GREY
	JMP	EXIT

GREY:	.while	esi < edi

		movzx	ecx, byte ptr[esi+2]	; red
		imul	ecx, ecx, 77

		movzx	edx, byte ptr[esi+1]	; green
		imul	edx, edx, 150
		add	ecx, edx

		movzx	eax, byte ptr[esi]		; blue
		imul	eax, eax, 29

		lea	eax, [eax+ecx+128]
		shr	eax, 8

		movzx	edx, al			; red
		add	edx, 30
		cmp	edx, 0FFh
		jbe	@F
		mov	edx, 0FFh
@@:		mov	[esi+2], dl

		mov	[esi+1], al		; green

		movzx	edx, al			; blue
		sub	edx, 30
		jns	@F
		mov	edx, 0
@@:		mov	[esi], dl

		add	esi, ebx

	.endw

EXIT:	ret

sepia	endp

;-------------------------------------------------------------------------------
; Process Windows messages. Notice the "clever" way I reuse the four input
; arguments by turning off MASM's normal prologue & epilogue, and simply doing
; a jump to the appropriate proc instead of a call.

OPTION	PROLOGUE:NONE
OPTION	EPILOGUE:NONE

align	16 ;  [esp+4]     [esp+8]    [esp+12]	   [esp+16]
wndproc	proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	mov	eax, [esp+8] ; msg
	cmp	eax, WM_PAINT
	je	wmpaint
	cmp	eax, WM_COMMAND
	je	CMD
	cmp	eax, WM_DESTROY
	je	wmdestroy
	jmp	DefWindowProc

CMD:	mov	eax, [esp+12] ; wparam
	and	eax, 0FFFFh
	cmp	eax, IDM_EXIT
	je	cmdquit
	cmp	eax, IDM_OPEN
	je	cmdopen
	cmp	eax, IDM_GREYSCALE
	je	cmdgrey
	cmp	eax, IDM_SEPIA
	je	cmdsepia
	cmp	eax, IDM_ABOUT
	je	cmdabout
	jmp	DefWindowProc

wndproc	endp

OPTION	PROLOGUE:PROLOGUEDEF
OPTION	EPILOGUE:EPILOGUEDEF

;-------------------------------------------------------------------------------
; Let user choose a file to open.

align	16
cmdopen	proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	local	path[MAX_PATH]:BYTE
	local	ofn:OPENFILENAME

	invoke	RtlZeroMemory, ADDR path, SIZEOF path
	invoke	RtlZeroMemory, ADDR ofn,  SIZEOF ofn

	mov	ofn.lStructSize,	sizeof ofn
	mov	ofn.Flags,	OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_HIDEREADONLY
	m2m	ofn.hwndOwner,	hwnd
	mov	ofn.lpstrFilter,	OFFSET szfiletypes
	mov	ofn.lpstrTitle,	_T("Open Picture File")
	lea	eax, path
	mov	ofn.lpstrFile,	eax
	mov	ofn.nMaxFile,	SIZEOF path

	invoke	GetOpenFileName, ADDR ofn
	cmp	eax, IDOK
	jne	EXIT
	invoke	readfile, ADDR path ; EAX <- mem handle, ECX <- mem size
	jz	E1
	invoke	loadbmp, eax, 0, ecx
	jz	E1

	; set global HBITMAP, but clear it first if it's already set

	push	eax
	cmp	ghbmp, 0
	je	@F
	invoke	DeleteObject, ghbmp
@@:	pop	ghbmp

	; force the window to redraw

	invoke	InvalidateRect, hwnd, NULL, TRUE
	jmp	EXIT

E1:	invoke	MessageBox, NULL, ecx, ADDR wndtitle, MB_ICONEXCLAMATION or MB_OK

EXIT:	ret

cmdopen	endp

;-------------------------------------------------------------------------------
; Convert displayed image to greyscale.

align	16
cmdgrey	proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	cmp	ghbmp, 0
	je	EXIT

	invoke	bmpfilter, ghbmp, ADDR greyscale
	invoke	InvalidateRect, hwnd, NULL, TRUE

EXIT:	ret

cmdgrey	endp

;-------------------------------------------------------------------------------
; Convert displayed image to sepia.

align	16
cmdsepia	proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	cmp	ghbmp, 0
	je	EXIT

	invoke	bmpfilter, ghbmp, ADDR sepia
	invoke	InvalidateRect, hwnd, NULL, TRUE

EXIT:	ret

cmdsepia	endp

;-------------------------------------------------------------------------------
; Show simple "about" dialog.

align	16
cmdabout	proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	local	mb:MSGBOXPARAMS

	invoke	RtlZeroMemory, ADDR mb,	SIZEOF mb
	mov	mb.cbSize,		SIZEOF mb
	m2m	mb.hwndOwner,		hwnd
	m2m	mb.hInstance,		hinst
	mov	mb.lpszText,		_T("This program was written in pure assembler!", 13, 10, 0A9h, " 2004 by Michael S. Lorenz")
	mov	mb.lpszCaption,		OFFSET wndtitle
	mov	mb.dwStyle,		MB_USERICON or MB_OK
	mov	mb.lpszIcon,		1001

	invoke	MessageBoxIndirect, ADDR mb
	ret

cmdabout	endp

;-------------------------------------------------------------------------------
; User selected Exit from the menu.

align	16
cmdquit	proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	invoke	SendMessage, hwnd, WM_SYSCOMMAND, SC_CLOSE, NULL
	ret

cmdquit	endp

;-------------------------------------------------------------------------------
; Process WM_PAINT.

align	16
wmpaint	proc uses ebx edi esi, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	local	ps:PAINTSTRUCT
	local	bm:BITMAP
	local	hdc:HDC
	local	wmetric:DWORD, hmetric:DWORD
	local	wpixels:DWORD, hpixels:DWORD
	local	oldobject:DWORD
	local	pt:POINT

	; get HDC

	invoke	BeginPaint, hwnd, ADDR ps
	mov	hdc, eax

	; test global HBITMAP

	cmp	ghbmp, 0
	je	DONE

	; EDI <- compatible DC

	invoke	CreateCompatibleDC, hdc
	mov	edi, eax

	; get bitmap info

	invoke	GetObject, ghbmp, SIZEOF bm, ADDR bm

	; select bitmap into DC

	invoke	SelectObject, edi, ghbmp
	mov	oldobject, eax

	; render the bitmap into the HDC

	xor	ecx, ecx
	invoke	BitBlt, hdc, ecx, ecx, bm.bmWidth, bm.bmHeight, edi, ecx, ecx, SRCCOPY

	; clean up

	invoke	SelectObject, edi, oldobject
	invoke	DeleteDC, edi

	; done painting

DONE:	invoke	EndPaint, hwnd, ADDR ps
	xor	eax, eax
	ret

wmpaint	endp

;-------------------------------------------------------------------------------
; Process WM_DESTROY.

align	16
wmdestroy proc, hwnd:dword, msg:dword, wparam:dword, lparam:dword

	invoke	PostQuitMessage, NULL
	ret

wmdestroy endp

;-------------------------------------------------------------------------------
; Initialize application.

align	16
myinit	proc

	local	wc:WNDCLASSEX, hwnd:HWND

	; initialize COM

	invoke	CoInitialize, 0

	; fill WNDCLASSEX structure with required variables

	invoke	RtlZeroMemory, ADDR wc,	SIZEOF WNDCLASSEX
	mov	wc.cbSize,		SIZEOF WNDCLASSEX
	mov	wc.style,			CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov	wc.lpfnWndProc,		OFFSET wndproc
	m2m	wc.hInstance,		hinst			; instance handle
	mov	wc.hbrBackground,		COLOR_WINDOW+1		; system color
	mov	wc.lpszMenuName,		NULL
	mov	wc.lpszClassName,		OFFSET wndclass		; window class name
	invoke	LoadIcon,			hinst, IDI_APPICON		; resource icon
	mov	wc.hIcon,			eax
	invoke	LoadCursor,		NULL, IDC_ARROW		; system cursor
	mov	wc.hCursor,		eax

	invoke	RegisterClassEx, ADDR wc	; register the window class
@@:
	; create the main application window

	xor	ecx, ecx
	mov	edx, CW_USEDEFAULT
	invoke	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, addr wndclass, addr wndtitle,
		WS_OVERLAPPEDWINDOW, edx, edx, edx, edx, ecx, ecx, hinst, ecx

	mov	hwnd, eax

	invoke	LoadMenu, hinst, IDM_APPMENU		; load resource menu
	invoke	SetMenu, hwnd, eax			; set it to main window

	invoke	ShowWindow, hwnd, SW_SHOWNORMAL	; display the window
	invoke	UpdateWindow, hwnd			; update the display

	ret

myinit	endp

;-------------------------------------------------------------------------------
; Cleanup application.

align	16
myexit	proc

	; release the image

	cmp	ghbmp, 0
	je	@F
	invoke	DeleteObject, ghbmp
@@:
	; release COM

	invoke	CoUninitialize
	ret

myexit	endp

;-------------------------------------------------------------------------------
; Main program.

align	16
WinMain	proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

	LOCAL	msg:MSG

	invoke	myinit
	jmp	G1

T1:	invoke	TranslateMessage, ADDR msg		; translate it
	invoke	DispatchMessage,  ADDR msg		; send it to message proc
G1:	invoke	GetMessage, ADDR msg, NULL, 0, 0	; get each message
	test	eax, eax
	jnz	T1

	invoke	myexit

	mov	eax, msg.wParam
	ret

WinMain	endp

;-------------------------------------------------------------------------------

end start
