@echo off

    : The name of the main exe & asm file
    set name=loadpic

    : Either windows or console
    set subsystem=windows

    if (%1)==(clean) goto clean

:assemble
    if (%1)==(debug) goto debug

:release
    echo ---RC---
    rc %name%.rc
    if errorlevel 1 goto errrc
    h2inc /WIN32 resource.h

    echo ---MASM---
    if exist %name%.ex~ del /Q %name%.ex~
    ml /c /nologo /coff /Fm *.asm
    if errorlevel 1 goto errasm

    echo ---LINK---
    \masm32\bin\link /nologo /subsystem:%subsystem% /out:"%name%.exe" *.obj *.res
    if errorlevel 1 goto errlink

    goto done

:debug
    echo ---RC---
    rc %name%.rc
    if errorlevel 1 goto errrc
    h2inc /WIN32 resource.h

    echo ---MASM---
    ml /c /nologo /coff /Zi /Zd /Fm /FR *.asm
    if errorlevel 1 goto errasm

    echo ---LINK---
    \masm32\bin\link /nologo /subsystem:%subsystem% /debug /out:"%name%.exe" /pdb:"%name%.pdb" /pdbtype:sept /map /mapinfo:lines *.obj *.res
    if errorlevel 1 goto errlink

    goto done

:clean
    if exist %name%.ilk   del /Q %name%.ilk
    if exist %name%.map   del /Q %name%.map
    if exist %name%.pdb   del /Q %name%.pdb
    if exist %name%.res   del /Q %name%.res
    if exist %name%.lst   del /Q *.lst
    if exist %name%.obj   del /Q *.obj
    if exist %name%.sbr   del /Q *.sbr
    if exist resource.inc del /Q resource.inc
    goto done

:errrc
    echo.
    echo RC error
    goto done

:errasm
    echo.
    echo Assembly error
    goto done

:errlink
    echo.
    echo Link error
    goto done

:done
    set name=
    set subsystem=
    echo on
